#ifndef __SPEA2__
#define __SPEA2__
//This file contain SPEA2 implementation for multi-objective optimization
//Programmed by NXH
//#include<conio.h>//Delete this line if you are in Unix
#include<iostream.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<assert.h>
#include "gconst.h"
#include "random.h"
#include "term.h"
#include "stree.h"
#include "genetic.h"
#include "symreg.h"
//#include "mulplex.h"
BOOL strongdominance;
FILE *fppop,*fppar,*fpstat;
//********************************************************************
//     Functions for checking dominance and some general functions   *
//********************************************************************


//*******************************************************************
//Pareto domination comparision (the less the better)               *
//*******************************************************************
BOOL Pdominate(pindividual p,pindividual q)
{
 double test1,test2;
 test1=p.iv.fitness-q.iv.fitness;
 test2=p.sfitness-q.sfitness;
//strong dominance
if(strongdominance)
 {
  if(((test1<0)&&(test2<=0))||((test1<=0)&&(test2<0)))
    return TRUE;
   else
  return FALSE;
 }
 else
 {
  //weak dominance
  if((test1<=0)&&(test2<=0))
   return TRUE;
  else
   return FALSE;
  }
}
BOOL Pequal(pindividual p,pindividual q)
{
 if((p.iv.fitness==q.iv.fitness)&&(p.sfitness==q.sfitness))
  return TRUE;
 else
  return FALSE;
}
//********************************************
// Check if the i-th individual is dominated *
//********************************************
BOOL Dominated(int i,pindividual *p,int size)
{
  int j;
  for(j=0;j<size;j++)
   if(i!=j)
    if(Pdominate(p[j],p[i]))
     return TRUE;
 return FALSE;
}
BOOL NonSDominated(int i,pindividual *p,int size)
{
  int j;
  for(j=0;j<size;j++)
   if(Pdominate(p[j],p[i])&&!Pequal(p[i],p[j]))
     return FALSE;
 return TRUE;
}
//***********************************************
//Copy a pindividual                            *
//***********************************************
pindividual CopyPindividual(pindividual p,BOOL a)
{
 pindividual q;
 q.iv=CopyIndividual(p.iv,a);
 q.sfitness=p.sfitness;
 q.pfitness=p.pfitness;
// q.knb=p.knb;
 return q;
}
//*********************************************
//Function for pertubating the pdinviduals    *
//*********************************************
void Pertubate(pindividual *p,int size,int times)
{
 pindividual temp;
 int i,j,k;
 for(i=0;i<times;i++)
  {
    j=IRandom(0,size-1);
    k=IRandom(0,size-1);
    temp=CopyPindividual(p[j],FALSE);
    p[j]=CopyPindividual(p[k],FALSE);
    p[k]=CopyPindividual(temp,FALSE);
  }
}
//***************************************************************************
//This function return archive length for generation > 0; return 0 otherwise*
//***************************************************************************
int Alen(void)
{
 if(gen==0)
   return 0;
 else
  return alen;
}

//*************************************************************
//   Functions for computing the fitnesses of pdindividuals   *
//*************************************************************


//****************************************************
//Compute the euclide distance on the decision space *
//****************************************************
double Edistance(double a,double b,double c,double d)
{
 return sqrt((a-c)*(a-c)+(b-d)*(b-d));
}
//***********************************
// Sort functions for double number *
//***********************************
int sort_function( const void *a, const void *b)
{
    if(*(double *)a>*(double *)b)
     return 1;
    else
     if(*(double *)a==*(double *)b)
      return 0;
       else
	return -1;
}
//***************************************
//Compute the k-th nearest neigbours    *
//***************************************
double ComputeKN(pindividual q,pindividual *p,int size,int k)
{
 double *temp;
 int i;
 double kr;
 temp=new double[size]; assert(temp!=NULL);
for(i=0;i<size;i++)
  temp[i]=Edistance(q.iv.fitness,q.sfitness,p[i].iv.fitness,p[i].sfitness);
//sort the list
 qsort((void *)temp,size,sizeof(double), sort_function);
 kr=temp[k-1];
 delete [] temp;
 return kr;
}
//*********************************************
//compute the fitness type- 0 phenotype size, *
//1- phenotype height, 2- genotype size       *
//*********************************************
void ComputeFitness(int type)
{
 int i,j, pos;
 individual t;
 double min,sum2,sum,sum3,min2;
 double *temp;
 //First Compute first fitness
 for(i=0;i<poplen;i++)
    oldpop[i].iv.fitness=ComputeRF(oldpop[i].iv);
 //Second Compute standardized first fitness
// for(i=0;i<poplen;i++)
//   oldpop[i].iv.fitness=(double) NUMFITCASE-oldpop[i].iv.fitness;
//Compute the second objective fitness
 for(i=0;i<poplen;i++)
   switch (type)
    {
      case 0: //phenotype size;
	   oldpop[i].sfitness=(double)oldpop[i].iv.size;
	   break;
     case 1: //phenotype height;
	   oldpop[i].sfitness=(double)oldpop[i].iv.height;
	   break;
    }

 //Find the best of the current population and archive
   pos=0;
   min=oldpop[0].iv.fitness;
   for(i=1;i<poplen+Alen();i++)
    if (oldpop[i].iv.fitness<min)
    {
      min=oldpop[i].iv.fitness;
      pos=i;
    }
// if there are multiple appearance of min then use the second objective to choose
  min2=oldpop[pos].sfitness;
  for(i=0;i<poplen+Alen();i++)
    if(oldpop[i].iv.fitness==min)
     if(oldpop[i].sfitness<min2)
      {
       min2=oldpop[i].sfitness;
       pos=i;
      }
   sum=0;
   sum2=0;
   sum3=0;
   for(i=0;i<poplen;i++)
   {
    sum+=oldpop[i].iv.fitness;
    sum2+=oldpop[i].sfitness;
    sum3+=oldpop[i].iv.size;
   }
 //copy the best and average
   bestcurrent[gen]=CopyIndividual(oldpop[pos].iv,TRUE);
   averagefitness[gen]=sum/poplen;
   averagesfitness[gen]=sum2/poplen;
   averagesize[gen]=sum3/poplen;
//compute the pareto fitness of the population and archive

//first compute the raw pfitness
  temp=new double[poplen+Alen()];assert(temp!=NULL);
  for(i=0;i<poplen+Alen();i++)
  {
    oldpop[i].pfitness=0.0;
    temp[i]=0.0;
  }
 for(i=0;i<poplen+Alen();i++)
   for(j=0;j<poplen+Alen();j++)
    if(j!=i)
     if(Pdominate(oldpop[i],oldpop[j]))
      temp[i]++;
  for(i=0;i<poplen+Alen();i++)
    for(j=0;j<poplen+Alen();j++)
     if(j!=i)
     if(Pdominate(oldpop[j],oldpop[i]))
       oldpop[i].pfitness+=temp[j];
  delete [] temp;
//compute pfitness
 j=(int) sqrt(poplen+Alen());
for(i=0;i<poplen+Alen();i++)
 oldpop[i].pfitness=oldpop[i].pfitness+(1/(ComputeKN(oldpop[i],oldpop,poplen+Alen(),j)+2));
}

//***********************************************************************
//Some display functions for statistics, pop and p-frontier progression *
//***********************************************************************
//******************************
//Display the Pareto frontier  *
//******************************
void ParetoDisplay(FILE *fp)
{
 int i,j;
 j=0;
 for(i=poplen;i<poplen+alen;i++)
  if (NonSDominated(i-poplen,&newpop[poplen],alen))
     j++;
if(!fp)
 {
  cout<<endl<<"Number of points:"<<j<<endl;
  for(i=poplen;i<poplen+alen;i++)
   if (NonSDominated(i-poplen,&newpop[poplen],alen))
      cout<<"("<<newpop[i].iv.fitness<<","<<newpop[i].sfitness<<") ";
   //getch();
  }
 else
 {
  fprintf(fp,"%d\n",j);
  for(i=poplen;i<poplen+alen;i++)
   if (NonSDominated(i-poplen,&newpop[poplen],alen))
      fprintf(fp,"%lf %lf ",newpop[i].iv.fitness,newpop[i].sfitness);
  fprintf(fp,"\n");
 }
}
void PopulationDisplay(FILE *fp)
{
 int i;
// cout<<endl;
if(!fp)
 {
  for(i=0;i<poplen;i++)
   cout<<"("<<oldpop[i].iv.fitness<<","<<oldpop[i].sfitness<<","<<oldpop[i].pfitness<<") ";
  //getch();
 }
 else
 {
   for(i=0;i<poplen;i++)
    fprintf(fp,"%lf %lf ",oldpop[i].iv.fitness,oldpop[i].sfitness);
   fprintf(fp,"\n");
 }
}

//********************************************************************
// Some functions for the main evolution loop (SPEA2-implementation) *
//********************************************************************

//*******************************************************
//Tournament Selection on the population of Pindividual *
//*******************************************************
int PTour(int size)
{
   int i,j,pos;
   double min;
   assert(size<=MAXTOUR);
   pos=IRandom(poplen,alen+poplen-1);
   min=newpop[pos].pfitness;
   for(i=1;i<size;i++)
    {
      j=IRandom(poplen,alen+poplen-1);
      if (newpop[j].pfitness<min)
       {
	 min=newpop[j].pfitness;
	 pos=j;
       }
    }
   return pos;
}
//****************************************
//sort function for the pareto fitness   *
//****************************************
int sort_function2( const void *a, const void *b)
{
    if(((pindividual *)a)->pfitness>((pindividual *)b)->pfitness)
     return 1;
    else
     if(((pindividual *)a)->pfitness==((pindividual *)b)->pfitness)
      return 0;
       else
	return -1;
}

void Evolution(char *filename)
{
 int i,j,l,k,mincount,pos,maxocc;
 double *knb;
 int *occs;
 FILE *f;
 pindividual *temp,parent1,parent2;
// stree s;
 double mink;
 BOOL dup;

 //Initialize a population from a file
/*f=fopen(filename,"rt");
  if(f==NULL)
   {
    cout<<endl<<"File For Initial Population not Found!";
    exit(1);
   }
  i=0;
  for(i=0;i<poplen;i++)
   {
    fgets(_sbuff,MAXSTRING,f);
    j=0;
    while(_sbuff[j]!='\n') j++;
   _sbuff[j]=0;
    _curchar=0;
    oldpop[i].iv.chrom=StringToTree();
    oldpop[i].iv.size=GetSizeNode(oldpop[i].iv.chrom,TRUE);
    oldpop[i].iv.height=GetHeightNode(oldpop[i].iv.chrom);
    oldpop[i].iv.branch=GetAVGNode(oldpop[i].iv.chrom);
   }
  fclose(f);*/
RampedInit(8,0.5);
//  cout<<"OK read file!"<<endl;
  gen=0;
  //initialize for population and archive

 while(gen<generation)
 {
   ComputeFitness(0);
//   cout<<"generation..."<<gen<<endl;
//   ParetoDisplay1();
 //first copy all nondominated solutions
  PopulationDisplay(fppop);
   j=poplen+alen;
   for(i=0;i<poplen+Alen();i++)
    if(!Dominated(i,oldpop,poplen+Alen())) //non dominated solutions
      {
       j--;
       newpop[j]=CopyPindividual(oldpop[i],TRUE);
      }
//if the archive is not filled up
  if(j>poplen)
  {
   //choosing the rest from the oldpop and the archive
   //first sort the oldpop and old archive
 //  cout<<endl<<"Filling up:";
   qsort((void *)oldpop,poplen+Alen(),sizeof(pindividual), sort_function2);
 // for(i=0;i<poplen+Alen();i++)
 //   cout<<"("<<oldpop[i].iv.fitness<<","<<oldpop[i].sfitness<<","<<oldpop[i].pfitness<<") ";
 //  getch();
   //choosing the best of the rest
   i=0;
   while(!Dominated(i,oldpop,poplen+Alen())) i++;
   while(j>poplen)
     {
      j--;
      newpop[j]=CopyPindividual(oldpop[i],TRUE);
      i++;
     }
  //  cout<<endl<<"Archive:"<<endl;
  //  for(i=poplen;i<poplen+Alen();i++)
  //  cout<<"("<<newpop[i].iv.fitness<<","<<newpop[i].sfitness<<","<<newpop[i].pfitness<<") ";
 //  getch();
   }
 if(j<poplen) //if it is over
  {
  // cout<<endl<<"Trunction";
   //eliminate the identical individuals first
   occs=new int[poplen+alen]; assert(occs!=NULL);
   for(i=j;i<poplen+alen;i++)
    occs[i]=1;
  for(i=j;i<poplen+alen;i++)
   if(occs[i]>0)
    for(k=i+1;k<poplen+alen;k++)
     if(Pequal(newpop[i],newpop[k]))
      {
       occs[i]++;
       occs[k]=0;
      }
   dup=TRUE;
  while(j<poplen && dup)
  {
   //find the maximum occurance
    maxocc=1;
    pos=j;
    for(i=j;i<poplen+alen;i++)
     if(occs[i]>maxocc)
      {
       maxocc=occs[i];
       pos=i;
      }
    if(maxocc==1)
     dup=FALSE;
    else
     {
      //randomly delelete the duplication
      k=IRandom(1,maxocc);
      //find the kth occurence
      i=j;
      while (k>0)
       {
	if(Pequal(newpop[i],newpop[pos]))
	 k--;
	if(k>0)
	 i++;
       }
     //delete that element
      if(i==pos)
	{
	//find next occurence of that individual
	 k=i+1;
	 while(!Pequal(newpop[k],newpop[i])) k++;
	  occs[k]=occs[i]-1;
	}
       else
	 occs[pos]--;
      //delete the element
       DeleteNode(newpop[i].iv.chrom);
       for(k=i;k>j;k--)
       {
	newpop[k]=CopyPindividual(newpop[k-1],FALSE);
	occs[k]=occs[k-1];
       }
       j++;
     }
  }
 delete [] occs;
 if(j<poplen)
 {
  // cout<<endl<<"truncation knb"<<endl;
   knb=new double[poplen+alen]; assert(knb!=NULL);
   while(j<poplen)
   {
    //truncation
    k=2;
   for(i=j;i<poplen+alen;i++)
    knb[i]=0.0;
  //find the individual for elimination
   while(k<=poplen+alen-j)
    {
     //compute k-nearest neighbor
     for(i=j;i<poplen+alen;i++)
      if(knb[i]>=0)
       knb[i]=ComputeKN(newpop[i],&newpop[j],poplen+alen-j,k);
    //find the minimum
     mink=999999999;
     for(i=j;i<poplen+alen;i++)
      if(knb[i]>=0)
       if(knb[i]<mink)
	{
	 mink=knb[i];
	 pos=i;
	}
     //counting the min
      mincount=0;
      for(i=j;i<poplen+alen;i++)
       if(knb[i]==mink)
	mincount++;
       else
	 knb[i]=-1;//won't count in future
      if(mincount==1)
       k=alen+poplen-j+1;
      else
       k++;
    }
  DeleteNode(newpop[pos].iv.chrom);
  for(i=pos;i>j;i--)
    newpop[i]=CopyPindividual(newpop[i-1],FALSE);
   j++;
  }
  delete [] knb;
 }
}
ParetoDisplay(fppar);
//Pertubate here
   l=0;
  while(l<poplen)
   {
    i=PTour(2);
    j=PTour(2);
    parent1=CopyPindividual(newpop[i],TRUE);
    parent2=CopyPindividual(newpop[j],TRUE);
   if(Flip(pcross))
   {
    if (SubTreeSwap(parent1.iv,parent2.iv,newpop[l].iv,newpop[l+1].iv))
      ncross++;
    else
     {
      newpop[l]=CopyPindividual(parent1,FALSE);
      newpop[l+1]=CopyPindividual(parent2,FALSE);
     }
   }
    else
     {
      newpop[l]=CopyPindividual(parent1,FALSE);
      newpop[l+1]=CopyPindividual(parent2,FALSE);
     }
 if(Flip(pmutate))
  if(ReplaceSubTree(newpop[l].iv,25,TRUE))
    nmutate++;
  if(Flip(pmutate))
   if(ReplaceSubTree(newpop[l+1].iv,25,TRUE))
    nmutate++;
    l+=2;
   }
  for(k=0;k<poplen+Alen();k++)
   DeleteNode(oldpop[k].iv.chrom);
  gen++;
  temp=oldpop;
  oldpop=newpop;
  newpop=temp;
 }
}
#endif
